/* ez-blob-basic.c: Basic encoder.

   Copyright (C) 2020 Michael Zucchi

   This program is free software: you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public License
   as published by the Free Software Foundation, either version 3 of
   the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this program. If not, see
   <http://www.gnu.org/licenses/>.
*/

#ifndef EZ_BLOB_BASIC_H
#define EZ_BLOB_BASIC_H

/*
  Currently 'basic' only has limited encoding support for
  primitive types, strings of int8, and embedded structures.
 */

size_t ez_basic_size(const ez_blob_desc *d, const void *p);

int ez_basic_encode_raw(const ez_blob_desc *d, const void *p, ez_blob *blob);
int ez_basic_encode(const ez_blob_desc *d, const void *p, ez_blob *blob);

int ez_basic_decode_raw(const ez_blob_desc *d, const ez_blob *blob, void *p);
void *ez_basic_decode(const ez_blob_desc *d, const ez_blob *blob);

#endif
